﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class CPlayerAStar : MonoBehaviour {

    // 플레이어 시작 위치
    //public Vector2 _initPosition;

    // 타일 매니저
    public CTileManager _tileManager;

    // * 경로 안내자
    PathFindSolver<CPathNode, System.Object> _aStar;

    // * 이동 경로 노드들
    IEnumerable<CPathNode> _pathNodes;

    // 이동 상태 여부
    bool _isMoving = false;

    // 위치이동용
    public Vector2 wp = Vector2.zero;

    Vector2 startPosition = Vector2.zero;
    Vector2 tPositon = Vector2.zero;

    public int WinCount = 0;

    public float done = 40f;

    public Text watch;

    // Use this for initialization
    void Start () {
        StartCoroutine("TimeCo");
	}

	void Update () {
        if (_isMoving) return;

        if (WinCount >= 3)
        {
            StopCoroutine("TimeCo");
            _tileManager.winImage[2].SetActive(true);
            //올클리어 팝업 노출
            _tileManager.OpenPopUp();
            //SceneManager.LoadScene("End");

            return;
        }

        

        if (WinCount == 1)
        {
            _tileManager.winImage[0].SetActive(true);
        }
        if (WinCount == 2)
        {
            _tileManager.winImage[1].SetActive(true);
        }
        

        if (Input.GetKey(KeyCode.LeftArrow))
        {
            Vector3 scale = transform.localScale;
            scale.x = -Mathf.Abs(scale.x);
            transform.localScale = scale;
            wp = new Vector2(transform.position.x - _tileManager._tileSize, transform.position.y);
            SelectMoveNode(wp);
        }

        if (Input.GetKey(KeyCode.RightArrow))
        {
            Vector3 scale = transform.localScale;
            scale.x = Mathf.Abs(scale.x);
            transform.localScale = scale;
            wp = new Vector2(transform.position.x + _tileManager._tileSize, transform.position.y);
            SelectMoveNode(wp);

        }

        if (Input.GetKey(KeyCode.UpArrow))
        {
            wp = new Vector2(transform.position.x, transform.position.y+ _tileManager._tileSize);
            SelectMoveNode(wp);
        }

        if (Input.GetKey(KeyCode.DownArrow))
        {
            wp = new Vector2(transform.position.x, transform.position.y- _tileManager._tileSize);
            SelectMoveNode(wp);
        }

        
    }

    IEnumerator TimeCo() {
        while (true) {
            if (done > 0f)
            {
                done -= Time.deltaTime;
                string result = string.Format("{0:#.00}", done);
                watch.text = "" + result + " sec";

            }
            else
            {
                SceneManager.LoadScene("Deth");
            }
            yield return null;
        }
    }

    // 터치한 곳으로 이동 작업을 시작함
    public void SelectMoveNode(Vector2 ipPosition)
    {
        // 이동 가능한 위치인지를 체크함
        //Collider2D collider = Physics2D.OverlapPoint(ipPosition, 1 << LayerMask.NameToLayer("Walkable"));
        Collider2D collider = Physics2D.OverlapPoint(ipPosition);

        if (collider == null)
        {
            return;
        }
        if (collider.tag == "final")
        {
            WinCount = WinCount + 1;
            _tileManager.lv = WinCount;

            done += 10f;
            MoveStart(new Vector2(0, 12.16f));
            _tileManager.CreateTiles();
        }

        if (collider.tag == "fuck")
        {
            MoveStart(collider.transform.position);
        }
        

    }

    // 경로에 맞게 이동을 수행함
    public void MoveStart(Vector2 targetPosition)
    {
        // 이미 이동 중이면 이동을 수행하지 않음
        if (_isMoving) return;

        // 이동 시작
        _isMoving = true;

        // 시작 위치 설정
        startPosition = transform.position;
        tPositon = targetPosition;
        
        StartCoroutine("MoveStartCoroutine");
    }

    IEnumerator MoveStartCoroutine()
    {
        
        // 현재 위치
        Vector2 currentPos = new Vector2(startPosition.x, startPosition.y);
        // 다음 위치
        Vector2 nextPos = new Vector2(tPositon.x , tPositon.y);
        
        // 이동 코루틴에 지연만큼 지연함
        yield return StartCoroutine(GameObjectMoveCoroutine(transform, currentPos, nextPos, 0.1f));
      

        // 이동이 끝남
        _isMoving = false;

        // 경로 색상 표시를 지워줌
        //_tileManager.ClearTileColor();
    }

    // 노드간의 보간 이동
    IEnumerator GameObjectMoveCoroutine(Transform thisTransform, Vector3 startPos, Vector3 endPos, float time)
    {
        // 시간을 기준으로 이동 크기를 보정함 (보간) => Lerp

        float i = 0.0f;
        float rate = 1.0f / time; // 보간 시간
        while (i < 1.0f) // 1초 간격 이동 위치를 갱신함
        {
            i += Time.deltaTime * rate;
            // 부드럽게 이동 
            thisTransform.position = Vector3.Lerp(startPos, endPos, i);
            yield return null; // Update!!
        }
    }
}
